/* ***************
// webmailcompose.js
// Main implementation file for WebMailCompose  <http://jedbrown.net/mozilla/>
//
// Author: Jed Brown (mozilla@jedbrown.net)
// Contributors:
//   ...
// License:
// See license.txt file from the original .xpi.
****************** */
  
  //Global Variables
  // ^T ^S ^M ^C ^B 
  var oldMailIntegration = window.MailIntegration; 
  var oldcontentAreaClick = window.contentAreaClick;
  
  var DefaultComposeReadURI = "https://gmail.google.com/";
  var DefaultComposeReadNewsURI = "http://groups.google.com/";
  var DefaultComposemailtoUrl = "mailto:?To=^T&Subject=^S&Body=^M&Cc=^C&Bcc=^B";;
  var GMailComposeURL = "https://gmail.google.com/?dest=https%3A%2F%2Fgmail%2Egoogle%2Ecom%2Fgmail%3Fview%3Dcm%26fs%3D1%26tearoff%3D1%26cmid%3D5%26to%3D^T%26su%3D^S%26body%3D^M%26cc%3D^C%26bcc%3D^B";
  var YahooComposeURL = "http://compose.mail.yahoo.com/?To=^T&Subject=^S&Body=^M&Cc=^C&Bcc=^B";
  var HotmailComposeURL = "http://hotmail.msn.com/cgi-bin/compose?To=^T&Subject=^S&Body=^M&Cc=^C&Bcc=^B&mailto=1";
  var Mail_ComComposeURL = "http://mail01.mail.com/scripts/mail/Outblaze.mail?composeto=^T&subject=^S&body=^M&cc=^C&bcc=&B&compose=1";
  var NetscapeComposeURL ="http://webmail.netscape.com/compose.adp?mailto=^T&mailcc=^C&mailbcc=^B&mailsubject=^S&mailbody=^B";
  var OperaComposeURL ="http://mymail.operamail.com/scripts/mail/Outblaze.mail?compose=1&did=1&a=1&to=^T&subject=^S&body=^M&cc=^C&bcc=^B";
  var HordeComposeURL ="http://YOUR_HordeURL_HERE.com/horde/imp/compose.php?popup=0&to=^T&cc=^C&bcc=^B&msg=^M&subject=^S";
  var SquirrelComposeURL ="http://YOUR_SquirrelURL_HERE.com/src/compose.php?send_to=^T&subject=^S&body=^M&send_to_cc=^C&send_to_bcc=^B";
  var OtherComposeURL = "http://YOUR_URL_HERE/?To_Field=^T&Subject_Field=^S&Body_Field=^M&Cc_FLield=^C&Bcc_Field=^B";
  var CompleteYahooComposeURL = "";
  var whichYMCbutton = 0;
  var gPreferences;
  getPrefYMailCompose().SetDefaultBoolPref("yahoocompose.overlaymailicon", true);
  getPrefYMailCompose().SetDefaultBoolPref("yahoocompose.leftclick", true);
  getPrefYMailCompose().SetDefaultBoolPref("yahoocompose.enablecm", true);
  getPrefYMailCompose().SetDefaultBoolPref("yahoocompose.YMCDebug_on", false);
  
  getPrefYMailCompose().SetDefaultBoolPref("yahoocompose.gmail", true);
  getPrefYMailCompose().SetDefaultBoolPref("yahoocompose.yahoo", false);
  getPrefYMailCompose().SetDefaultBoolPref("yahoocompose.hotmail", false);
  getPrefYMailCompose().SetDefaultBoolPref("yahoocompose.mail_com", false);
  getPrefYMailCompose().SetDefaultBoolPref("yahoocompose.netscape", false);
  getPrefYMailCompose().SetDefaultBoolPref("yahoocompose.opera", false);
  getPrefYMailCompose().SetDefaultBoolPref("yahoocompose.horde", false);
  getPrefYMailCompose().SetDefaultBoolPref("yahoocompose.squirrel", false);
  getPrefYMailCompose().SetDefaultBoolPref("yahoocompose.other", false);
  getPrefYMailCompose().SetDefaultBoolPref("yahoocompose.default", false);
  
  getPrefYMailCompose().SetDefaultCharPref("yahoocompose.defaultreadmailurl", DefaultComposeReadURI);
  getPrefYMailCompose().SetDefaultCharPref("yahoocompose.defaultreadnewsurl", DefaultComposeReadNewsURI);
  
  getPrefYMailCompose().SetDefaultCharPref("yahoocompose.gmail.uri", GMailComposeURL);
  getPrefYMailCompose().SetDefaultCharPref("yahoocompose.yahoo.uri", YahooComposeURL);
  getPrefYMailCompose().SetDefaultCharPref("yahoocompose.hotmail.uri", HotmailComposeURL);
  getPrefYMailCompose().SetDefaultCharPref("yahoocompose.mail_com.uri", Mail_ComComposeURL);
  getPrefYMailCompose().SetDefaultCharPref("yahoocompose.netscape.uri", NetscapeComposeURL);
  getPrefYMailCompose().SetDefaultCharPref("yahoocompose.opera.uri", OperaComposeURL);
  getPrefYMailCompose().SetDefaultCharPref("yahoocompose.horde.uri", HordeComposeURL);
  getPrefYMailCompose().SetDefaultCharPref("yahoocompose.squirrel.uri", SquirrelComposeURL);
  getPrefYMailCompose().SetDefaultCharPref("yahoocompose.other.uri", OtherComposeURL);
  
  getPrefYMailCompose().SetDefaultCharPref("yahoocompose.service", "gmail");
  //getPrefYMailCompose().SetDefaultCharPref("yahoocompose.URI", GMailComposeURL);
  
  
  var WebMailCompose_OverlayMailIcon = null;
  var YMCDebug_on = null;
  var ShowGMCContextMenu = null;
  var YahoomailComposeEnableHotmail = null;
  
  var YahoomailCompose_gmail = null;
  var YahoomailCompose_yahoo = null;
  var YahoomailCompose_hotmail = null;
  var YahoomailCompose_mail_com = null;
  var YahoomailCompose_netscape = null;
  var YahoomailCompose_opera = null;
  var YahoomailCompose_horde = null;
  var YahoomailCompose_squirrel = null;
  var YahoomailCompose_other = null;
  var YahoomailCompose_default = null;
  
  var DefaultComposeReadURL = null;
  var DefaultComposeReadNewsURL = null;
  
  var YahoomailCompose_gmail_uri = null;
  var YahoomailCompose_yahoo_uri = null;
  var YahoomailCompose_hotmail_uri = null;
  var YahoomailCompose_netscape_uri = null;
  var YahoomailCompose_opera_uri = null;
  var YahoomailCompose_horde_uri = null;
  var YahoomailCompose_squirrel_uri = null;
  var YahoomailCompose_mail_com_uri = null;
  var YahoomailCompose_other_uri = null;
  yahoocompose_GetUserPrefs();
  
  
    if(getPrefYMailCompose().GetBoolPref("yahoocompose.leftclick") == true){
      whichYMCbutton = 0;
    }else{
      whichYMCbutton = -1;
    }
    

//http://www.xulplanet.com/references/xpcomref/ifaces/nsIPref.html  
function getPrefYMailCompose() {
  if (!gPreferences) {
    try {
      gPreferences = Components.classes["@mozilla.org/preferences;1"].getService();
      gPreferences = gPreferences.QueryInterface(
        Components.interfaces.nsIPref);
    } catch (e) {}
  }

  return gPreferences;
}

function yahoocompose_OpenSettings() {
  var fromEM = false;
  window.openDialog('chrome://webmailcompose/content/prefDialog.xul', 'Settings','chrome,modal,centerscreen',fromEM,null);
}

function yahoocompose_GetUserPrefs() {
  WebMailCompose_OverlayMailIcon = getPrefYMailCompose().GetBoolPref("yahoocompose.overlaymailicon");
  YMCDebug_on = getPrefYMailCompose().GetBoolPref("yahoocompose.YMCDebug_on");
  ShowGMCContextMenu = getPrefYMailCompose().GetBoolPref("yahoocompose.enablecm");
  //YahoomailComposeURI = getPrefYMailCompose().GetCharPref("yahoocompose.URI");
  YahoomailComposeEnableHotmail = getPrefYMailCompose().GetCharPref("yahoocompose.service");
  
  YahoomailCompose_gmail = getPrefYMailCompose().GetBoolPref("yahoocompose.gmail");
  YahoomailCompose_yahoo = getPrefYMailCompose().GetBoolPref("yahoocompose.yahoo");
  YahoomailCompose_hotmail = getPrefYMailCompose().GetBoolPref("yahoocompose.hotmail");
  YahoomailCompose_mail_com = getPrefYMailCompose().GetBoolPref("yahoocompose.mail_com");
  YahoomailCompose_netscape = getPrefYMailCompose().GetBoolPref("yahoocompose.netscape");
  YahoomailCompose_opera = getPrefYMailCompose().GetBoolPref("yahoocompose.opera");
  YahoomailCompose_horde = getPrefYMailCompose().GetBoolPref("yahoocompose.horde");
  YahoomailCompose_squirrel = getPrefYMailCompose().GetBoolPref("yahoocompose.squirrel");
  YahoomailCompose_other = getPrefYMailCompose().GetBoolPref("yahoocompose.other");
  YahoomailCompose_default = getPrefYMailCompose().GetBoolPref("yahoocompose.default");
  
  DefaultComposeReadURL = getPrefYMailCompose().GetCharPref("yahoocompose.defaultreadmailurl");
  DefaultComposeReadNewsURL = getPrefYMailCompose().GetCharPref("yahoocompose.defaultreadnewsurl");
  
  YahoomailCompose_gmail_uri = getPrefYMailCompose().GetCharPref("yahoocompose.gmail.uri");
  YahoomailCompose_yahoo_uri = getPrefYMailCompose().GetCharPref("yahoocompose.yahoo.uri");
  YahoomailCompose_hotmail_uri = getPrefYMailCompose().GetCharPref("yahoocompose.hotmail.uri");
  YahoomailCompose_netscape_uri = getPrefYMailCompose().GetCharPref("yahoocompose.netscape.uri");
  YahoomailCompose_opera_uri = getPrefYMailCompose().GetCharPref("yahoocompose.opera.uri");
  YahoomailCompose_horde_uri = getPrefYMailCompose().GetCharPref("yahoocompose.horde.uri");
  YahoomailCompose_squirrel_uri = getPrefYMailCompose().GetCharPref("yahoocompose.squirrel.uri");
  YahoomailCompose_mail_com_uri = getPrefYMailCompose().GetCharPref("yahoocompose.mail_com.uri");
  YahoomailCompose_other_uri = getPrefYMailCompose().GetCharPref("yahoocompose.other.uri");
}

 
 // QueryString Function thank to MonkeySagee on the mozillazine forums!
var QueryString = function(str) {
   this.vals  = new Array();
   this.keys  = new Array();
   this.query = str;
};

 // QueryString.prototype Function thank to MonkeySagee on the mozillazine forums!
QueryString.prototype = {

   init : function() {
      this.parse();
      var Search = {
         init : function(keys, vals) {
            this.keys = keys;
            this.vals = vals;
         },
         search : function (key) {
            var value = new String(), n;
            for (n = 0; n < this.keys.length; n++) {
               if (this.keys[n].toLowerCase() == key.toLowerCase()) {
                  value = this.vals[n];
                  break;
               }
            }
            return unescape(value);
         }
      }
      Search.init(this.keys, this.vals);
      this.keys['search'] = function (key) { return Search.search(key); }
   },
   
   list : function() {
      var arr = new Array(), n;
      for (n = 0; n < this.keys.length; ++n) {
         arr.push(this.keys[n] + '=' + this.vals[n]);
      }
      return arr;
   },
 
   parse : function() {
      var pairs = this.query.split('&'), n, pos;
      for (n = 0; n < pairs.length; n++) {
         pos = pairs[n].indexOf('=');
         if (pos > -1) {
            this.keys[this.keys.length] = pairs[n].substring(0, pos);
            this.vals[this.vals.length] = pairs[n].substring(pos + 1);
         }
      }
      for (n = 0; n < this.keys.length; ++n) {
         this.keys[this.keys[n]] = this.vals[n];
      }
   }
   
}

function replaceText(inString,oldText,newText) {
return (inString.split(oldText).join(newText));
}

function replaceSubstring(text,expression,value){
var exp = new RegExp(expression,'g')
return text.replace(exp,value)
}


function yahoocompose_RightClick(yahoocompose_service) {
  var focusedWindow = document.commandDispatcher.focusedWindow;  
if (focusedWindow == window){
          focusedWindow = _content;
          }
        var docCharset = null;
        if (focusedWindow){
          docCharset = "charset=" + focusedWindow.document.characterSet;
	}
	var elem = document.popupNode;
	var copiedemailAddressGC = null;
	
		if(elem) {
			if(elem instanceof Components.interfaces.nsIDOMHTMLAnchorElement && elem.href){
				copiedemailAddressGC = elem.href.toString();
			}else{
				copiedemailAddressGC = elem.parentNode.toString();
			}
		}
    
    var theSubmitedEmailAddress = copiedemailAddressGC;
    yahoolcompose_ComposeIT(theSubmitedEmailAddress, yahoocompose_service);
}


function yahoocompose_ComposeSelected(yahoocompose_service) {
  var focusedWindow = document.commandDispatcher.focusedWindow;  
if (focusedWindow == window){
          focusedWindow = _content;
          }
        var docCharset = null;
        if (focusedWindow){
          docCharset = "charset=" + focusedWindow.document.characterSet;
	}
	var copiedemailAddressGC = focusedWindow.__proto__.getSelection.call(focusedWindow).toString();
  
  var theSubmitedEmailAddress = copiedemailAddressGC;
  yahoolcompose_ComposeIT(theSubmitedEmailAddress, yahoocompose_service);
}

function yahoocompose_replaceSpacesWith(thePassingValue, yahoocompose_service){
      if(yahoocompose_service == "gmail"){
        thePassingValue = replaceText(thePassingValue, " ", "%2520");
      }else{
        thePassingValue = replaceText(thePassingValue, " ", "%20");
      }
      return thePassingValue;
}

//encodeURIComponent
function yahoolcompose_ComposeIT(theSubmitedEmailAddress, yahoocompose_service){
    //TEMP
  //theSubmitedEmailAddress ="mailto:dude@dude.org?subject=This is a Subject&body=The body dude&cc=dude2@dude.unl.edu,dude3@dude.unl.edu";
    var arr = theSubmitedEmailAddress.split('?');
    var recipient = arr[0].replace('mailto:', '');
    //arr[1] = replaceText(arr[1], "?", "%3F");
    try{
    var qs  = new QueryString(arr[1]);
      qs.init();
    }catch (e){
      //Foo
    }
    try{
      //%26su%3DYour%2520Subject%2520Line
      var subject = qs.keys.search('subject');
      subject = yahoocompose_replaceSpacesWith(subject, yahoocompose_service);
    }catch (e){
      //Foo
      subject = "";
    }
    try{
      //%26body%3DBlahblah
      var body = qs.keys.search('body');
      body = yahoocompose_replaceSpacesWith(body, yahoocompose_service);
    }catch (e){
      //Foo
      body = "";
    }
    try{
      //%26cc%3D
      var cc = qs.keys.search('cc');
      cc = yahoocompose_replaceSpacesWith(cc, yahoocompose_service);
    }catch (e){
      //Foo
      cc = "";
    }
    try{
      //%26bcc%3D
      var bcc = qs.keys.search('bcc');
      bcc = yahoocompose_replaceSpacesWith(bcc, yahoocompose_service);
    }catch (e){
      //Foo
      bcc = "";
    }
    
//    theSubmitedEmailAddress = replaceText(YahoomailComposeURI, "mailto:", "");
    //Need to choose the mail server!!
    var yahocompose_theMailToURLToBeUsed;
    if(yahoocompose_service == "gmail"){
      yahocompose_theMailToURLToBeUsed = YahoomailCompose_gmail_uri;
    }
    if(yahoocompose_service == "yahoo"){
      yahocompose_theMailToURLToBeUsed = YahoomailCompose_yahoo_uri;
    }
    if(yahoocompose_service == "hotmail"){
      yahocompose_theMailToURLToBeUsed = YahoomailCompose_hotmail_uri;
    }
    if(yahoocompose_service == "mail.com"){
      yahocompose_theMailToURLToBeUsed = YahoomailCompose_mail_com_uri;
    }
    if(yahoocompose_service == "netscape"){
      yahocompose_theMailToURLToBeUsed = YahoomailCompose_netscape_uri;
    }
    if(yahoocompose_service == "opera"){
      yahocompose_theMailToURLToBeUsed = YahoomailCompose_opera_uri;
    }
    if(yahoocompose_service == "horde"){
      yahocompose_theMailToURLToBeUsed = YahoomailCompose_horde_uri;
    }
    if(yahoocompose_service == "squirrel"){
      yahocompose_theMailToURLToBeUsed = YahoomailCompose_squirrel_uri;
    }
    if(yahoocompose_service == "other"){
      yahocompose_theMailToURLToBeUsed = YahoomailCompose_other_uri;
    }
    if(yahoocompose_service == "default"){
      yahocompose_theMailToURLToBeUsed = DefaultComposemailtoUrl;
    }

    
    yahocompose_theMailToURLToBeUsed = replaceText(yahocompose_theMailToURLToBeUsed, "^T", recipient);
    yahocompose_theMailToURLToBeUsed = replaceText(yahocompose_theMailToURLToBeUsed, "^S", subject);
    yahocompose_theMailToURLToBeUsed = replaceText(yahocompose_theMailToURLToBeUsed, "^M", body);
    yahocompose_theMailToURLToBeUsed = replaceText(yahocompose_theMailToURLToBeUsed, "^C", cc);
    yahocompose_theMailToURLToBeUsed = replaceText(yahocompose_theMailToURLToBeUsed, "^B", bcc);
    yahocompose_theMailToURLToBeUsed = replaceText(yahocompose_theMailToURLToBeUsed, "@", "%40");
    theSubmitedEmailAddress = replaceText(yahocompose_theMailToURLToBeUsed, ".", "%2E");


    CompleteYahooComposeURL = yahocompose_theMailToURLToBeUsed;

    if(yahoocompose_service == "default"){
      // generate a mailto url based on the url and the url's title
       var ioService = Components.classes["@mozilla.org/network/io-service;1"].getService(Components.interfaces.nsIIOService);
       var uri = ioService.newURI(CompleteYahooComposeURL, null, null);
   
       // now pass this url to the operating system
       oldMailIntegration._launchExternalUrl(uri);
    }else{
      var yahooComposeTab = gBrowser.addTab(CompleteYahooComposeURL);
      getBrowser().selectedTab = yahooComposeTab;
    }
}

// http://amuck.ath.cx/mailtest.html 
window.contentAreaClick = function(event, fieldNormalClicks) {
  var islink = false;
  //Debug
  if (YMCDebug_on){
    alert("1) contentAreaClick is Called!");
  }
  // Get from prefs what button should be used (middle, left or none)
  if ( event.button == whichYMCbutton){
    if (YMCDebug_on){
      alert("2) Left-Click is catched!");
    }
    //var linkString = event.target.toString();
    var linkString;
    try{
      //The parentNode is just incase we have an image or other object wrapped around a mailto link.
      linkString = event.originalTarget.parentNode.getAttribute('href').toString();
    }catch (e) {
      linkString = "Null";
    }
    
    try{
      linkString = event.originalTarget.getAttribute('href').toString();
    }catch (e) {
      //Foobar
    }
    //alert("event.originalTarget.parentNode.getAttribute('href') = " + event.originalTarget.parentNode.getAttribute('href'));
    //alert("Is this a MAILTO: LINK!!\n linkString = " + linkString + " Event.button = " + event.button);
    if (YMCDebug_on){
      alert("3) linkString is " + linkString);
    }
    if(linkString.indexOf("mailto:") > -1 && linkString.indexOf("mailto:") < 7){
      //alert("This is a MAILTO: LINK!!\n linkString = " + linkString + " Event.button = " + event.button);
      if(YahoomailComposeEnableHotmail != "default"){
        islink = true;
        yahoolcompose_ComposeIT(linkString, YahoomailComposeEnableHotmail);
      }
    }
    

  }
      //gmailcompose_Compose();
    if(islink == false){
      oldcontentAreaClick(event, fieldNormalClicks);
    }else{
      return false;
    }
}


MailIntegration = {
   sendLinkForContent: function ()
   {
     if(WebMailCompose_OverlayMailIcon == false){
       oldMailIntegration.sendLinkForContent();
     }else{
      this.sendMessage(Components.lookupMethod(window._content, 'location').call(window._content).href,
                      Components.lookupMethod(window._content.document, 'title').call(window._content.document));
     }
   },
 
   sendMessage: function (aBody, aSubject) 
   {
     if(WebMailCompose_OverlayMailIcon == false){
       oldMailIntegration.sendMessage(aBody, aSubject);
     }else{
       // generate a mailto url based on the url and the url's title
       var mailtoUrl = aBody ? "mailto:?body=" + encodeURIComponent(aBody) + "&subject=" + encodeURIComponent(aSubject) : "mailto:";
       yahoolcompose_ComposeIT(mailtoUrl, YahoomailComposeEnableHotmail);
     }
   },
   //YahoomailComposeEnableHotmail
   // a generic method which can be used to pass arbitrary urls to the operating system.
   // aURL --> a nsIURI which represents the url to launch
   _launchExternalUrl: function(aURL)
   {
     if(WebMailCompose_OverlayMailIcon == false){
       oldMailIntegration._launchExternalUrl(aURL);
     }else{
       var extProtocolSvc = Components.classes["@mozilla.org/uriloader/external-protocol-service;1"].getService(Components.interfaces.nsIExternalProtocolService);
       if (extProtocolSvc)
         extProtocolSvc.loadUrl(aURL);
     }
   },
   
   readMail: function ()
   {
     if(WebMailCompose_OverlayMailIcon == false){
       oldMailIntegration.readMail();
     }else{
      var yahooComposeTab = gBrowser.addTab(DefaultComposeReadURL);
      getBrowser().selectedTab = yahooComposeTab;
     }
   },
   
   readNews: function ()
   {
     if(WebMailCompose_OverlayMailIcon == false){
       oldMailIntegration.readNews();
     }else{
       var yahooComposeTab = gBrowser.addTab(DefaultComposeReadNewsURL);
       getBrowser().selectedTab = yahooComposeTab;
     }
   },
   
   updateUnreadCount: function ()
   {
     if(WebMailCompose_OverlayMailIcon == false){
       oldMailIntegration.updateUnreadCount();
     }else{
       var shell = Components.classes["@mozilla.org/browser/shell-service;1"]
                             .getService(Components.interfaces.nsIWindowsShellService);
       var unreadCount = shell.unreadMailCount;
       var message = gNavigatorBundle.getFormattedString("mailUnreadTooltip", [0]);
       var element = document.getElementById("mail-button");
       if (element)
         element.setAttribute("tooltiptext", message);
                                                                 
       message = gNavigatorBundle.getFormattedString("mailUnreadMenuitem", [0]);
       element = document.getElementById("Browser:ReadMail");
       element.setAttribute("label", message);
     }
   }
}

